Index: trunk/tools/Templates/HeuristicLab 3.3 Plugin Template/HeuristicLab.Plugin.csproj
===================================================================
--- trunk/tools/Templates/HeuristicLab 3.3 Plugin Template/HeuristicLab.Plugin.csproj	(revision 5388)
+++ trunk/tools/Templates/HeuristicLab 3.3 Plugin Template/HeuristicLab.Plugin.csproj	(revision 5390)
@@ -11,7 +11,6 @@
     <RootNamespace>$safeprojectname$</RootNamespace>
     <AssemblyName>$projectname$-3.3</AssemblyName>
-    <TargetFrameworkVersion>v3.5</TargetFrameworkVersion>
+    <TargetFrameworkVersion>v4.0</TargetFrameworkVersion>
     <FileAlignment>512</FileAlignment>
-    <TargetFrameworkProfile />
   </PropertyGroup>
   <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
@@ -103,4 +102,7 @@
   </PropertyGroup>
   <ItemGroup>
+    <Reference Include="HeuristicLab.PluginInfrastructure-3.3">
+      <HintPath>C:\Program Files\HeuristicLab 3.3\PluginInfrastructure-3.3.dll</HintPath>
+    </Reference>
     <Reference Include="System" />
     <Reference Include="System.Core" />
@@ -116,10 +118,4 @@
   <ItemGroup>
     <None Include="HeuristicLab.snk" />
-  </ItemGroup>
-  <ItemGroup>
-    <ProjectReference Include="..\..\HeuristicLab.PluginInfrastructure\3.3\HeuristicLab.PluginInfrastructure-3.3.csproj">
-      <Project>{94186A6A-5176-4402-AE83-886557B53CCA}</Project>
-      <Name>HeuristicLab.PluginInfrastructure-3.3</Name>
-    </ProjectReference>
   </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
Index: trunk/tools/Templates/HeuristicLab 3.3 Plugin Template/InstallTemplate.cmd
===================================================================
--- trunk/tools/Templates/HeuristicLab 3.3 Plugin Template/InstallTemplate.cmd	(revision 5388)
+++ trunk/tools/Templates/HeuristicLab 3.3 Plugin Template/InstallTemplate.cmd	(revision 5390)
@@ -2,3 +2,2 @@
 "%ProgramFiles%\7-Zip\7z" a "%ZIPFILENAME%" Properties HeuristicLab.Plugin.csproj HeuristicLab.snk HeuristicLabIcon.ico Plugin.cs Plugin.cs.frame PluginProjectTemplate.vstemplate
 copy "%ZIPFILENAME%" "%UserProfile%\Documents\Visual Studio 2010\Templates\ProjectTemplates\Visual C#\"
-DEL "%ZIPFILENAME%"
Index: trunk/tools/Templates/HeuristicLabVS2010WizardsInstaller/HeuristicLabVS2010WizardsInstaller.vdproj
===================================================================
--- trunk/tools/Templates/HeuristicLabVS2010WizardsInstaller/HeuristicLabVS2010WizardsInstaller.vdproj	(revision 5388)
+++ trunk/tools/Templates/HeuristicLabVS2010WizardsInstaller/HeuristicLabVS2010WizardsInstaller.vdproj	(revision 5390)
@@ -16,4 +16,10 @@
         "Entry"
         {
+        "MsmKey" = "8:_05A3CD7212E641D7AABFE7C83B1A95EF"
+        "OwnerKey" = "8:_UNDEFINED"
+        "MsmSig" = "8:_UNDEFINED"
+        }
+        "Entry"
+        {
         "MsmKey" = "8:_102F3FAFA05819C62F87BFEFD5F1C0C9"
         "OwnerKey" = "8:_B51E170D986C45DD9BBEEC6B70686DC9"
@@ -203,4 +209,24 @@
         "File"
         {
+            "{1FB2D0AE-D3B9-43D4-B9DD-F88EC61E35DE}:_05A3CD7212E641D7AABFE7C83B1A95EF"
+            {
+            "SourcePath" = "8:..\\HeuristicLab 3.3 Plugin Template\\HeuristicLab 3.3 Plugin Template.zip"
+            "TargetName" = "8:HeuristicLab 3.3 Plugin Template.zip"
+            "Tag" = "8:"
+            "Folder" = "8:_1CDC4FAF99F44A4E856732AEFC20FAB8"
+            "Condition" = "8:"
+            "Transitive" = "11:FALSE"
+            "Vital" = "11:TRUE"
+            "ReadOnly" = "11:FALSE"
+            "Hidden" = "11:FALSE"
+            "System" = "11:FALSE"
+            "Permanent" = "11:FALSE"
+            "SharedLegacy" = "11:FALSE"
+            "PackageAs" = "3:1"
+            "Register" = "3:1"
+            "Exclude" = "11:FALSE"
+            "IsDependency" = "11:FALSE"
+            "IsolateTo" = "8:"
+            }
             "{9F6F8455-1EF1-4B85-886A-4223BCC8E7F7}:_102F3FAFA05819C62F87BFEFD5F1C0C9"
             {
@@ -409,4 +435,26 @@
                                 "Folders"
                                 {
+                                    "{9EF0B969-E518-4E46-987F-47570745A589}:_220AC1CBA0904F879BCEF1A0BFFEE9DC"
+                                    {
+                                    "Name" = "8:ProjectTemplates"
+                                    "AlwaysCreate" = "11:FALSE"
+                                    "Condition" = "8:"
+                                    "Transitive" = "11:FALSE"
+                                    "Property" = "8:_8046FC50DB2747AD88108A26491C9719"
+                                        "Folders"
+                                        {
+                                            "{9EF0B969-E518-4E46-987F-47570745A589}:_1CDC4FAF99F44A4E856732AEFC20FAB8"
+                                            {
+                                            "Name" = "8:Visual C#"
+                                            "AlwaysCreate" = "11:FALSE"
+                                            "Condition" = "8:"
+                                            "Transitive" = "11:FALSE"
+                                            "Property" = "8:_BA93FB8E5BD94A668C5DE542105242E3"
+                                                "Folders"
+                                                {
+                                                }
+                                            }
+                                        }
+                                    }
                                     "{9EF0B969-E518-4E46-987F-47570745A589}:_39EF377865F94878B7F5EC5C5E3729F9"
                                     {
@@ -421,5 +469,5 @@
                                             {
                                             "Name" = "8:Visual C#"
-                                            "AlwaysCreate" = "11:TRUE"
+                                            "AlwaysCreate" = "11:FALSE"
                                             "Condition" = "8:"
                                             "Transitive" = "11:FALSE"
@@ -619,18 +667,4 @@
         "Shortcut"
         {
-            "{970C0BB2-C7D0-45D7-ABFA-7EC378858BC0}:_640D4F41D6084D93A4C87B88C633E382"
-            {
-            "Name" = "8:Visual C# Templates"
-            "Arguments" = "8:"
-            "Description" = "8:"
-            "ShowCmd" = "3:1"
-            "IconIndex" = "3:0"
-            "Transitive" = "11:FALSE"
-            "Target" = "8:_E33A3941E42F482B99D2418470C8A183"
-            "Folder" = "8:_EB8295E99C2A46578D53F50F3B4F5A64"
-            "WorkingFolder" = "8:_E33A3941E42F482B99D2418470C8A183"
-            "Icon" = "8:"
-            "Feature" = "8:"
-            }
         }
         "UserInterface"
Index: trunk/tools/Templates/VS2010Wizards.sln
===================================================================
--- trunk/tools/Templates/VS2010Wizards.sln	(revision 5388)
+++ trunk/tools/Templates/VS2010Wizards.sln	(revision 5390)
@@ -33,4 +33,21 @@
 		HeuristicLabProblemTemplate\InstallTemplate.cmd = HeuristicLabProblemTemplate\InstallTemplate.cmd
 		HeuristicLabProblemTemplate\MyTemplate.vstemplate = HeuristicLabProblemTemplate\MyTemplate.vstemplate
+	EndProjectSection
+EndProject
+Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "HeuristicLab 3.3 Plugin Template", "HeuristicLab 3.3 Plugin Template", "{1562A0EE-488D-4BC2-AA4D-D0C33EADE000}"
+	ProjectSection(SolutionItems) = preProject
+		HeuristicLab 3.3 Plugin Template\HeuristicLab.Plugin.csproj = HeuristicLab 3.3 Plugin Template\HeuristicLab.Plugin.csproj
+		HeuristicLab 3.3 Plugin Template\HeuristicLab.snk = HeuristicLab 3.3 Plugin Template\HeuristicLab.snk
+		HeuristicLab 3.3 Plugin Template\HeuristicLabIcon.ico = HeuristicLab 3.3 Plugin Template\HeuristicLabIcon.ico
+		HeuristicLab 3.3 Plugin Template\InstallTemplate.cmd = HeuristicLab 3.3 Plugin Template\InstallTemplate.cmd
+		HeuristicLab 3.3 Plugin Template\Plugin.cs = HeuristicLab 3.3 Plugin Template\Plugin.cs
+		HeuristicLab 3.3 Plugin Template\Plugin.cs.frame = HeuristicLab 3.3 Plugin Template\Plugin.cs.frame
+		HeuristicLab 3.3 Plugin Template\PluginProjectTemplate.vstemplate = HeuristicLab 3.3 Plugin Template\PluginProjectTemplate.vstemplate
+	EndProjectSection
+EndProject
+Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "Properties", "Properties", "{F6B35DE9-F01C-4D6D-8609-91C38B7D4B35}"
+	ProjectSection(SolutionItems) = preProject
+		HeuristicLab 3.3 Plugin Template\Properties\AssemblyInfo.cs = HeuristicLab 3.3 Plugin Template\Properties\AssemblyInfo.cs
+		HeuristicLab 3.3 Plugin Template\Properties\AssemblyInfo.frame = HeuristicLab 3.3 Plugin Template\Properties\AssemblyInfo.frame
 	EndProjectSection
 EndProject
@@ -75,4 +92,6 @@
 		{0F752C36-F6AD-480A-9720-CCEB240BE914} = {28A05A91-A678-43B9-8573-0A7461E20F81}
 		{3577ED45-0083-4164-89B3-01B3CE77B279} = {28A05A91-A678-43B9-8573-0A7461E20F81}
+		{1562A0EE-488D-4BC2-AA4D-D0C33EADE000} = {28A05A91-A678-43B9-8573-0A7461E20F81}
+		{F6B35DE9-F01C-4D6D-8609-91C38B7D4B35} = {1562A0EE-488D-4BC2-AA4D-D0C33EADE000}
 	EndGlobalSection
 EndGlobal